%% GUI fr CNC-Frse 
% Autor: Lars Osthoff
% Hochschule Hamm-Lippstadt
% Produktionstechnik Praktikum WS15/16
% Prof. Dr. -Ing Gbel
% in Anlehnung an vorherige Semester

%% Start

clear;
close all;
clc;

%Einstellen des Wertebereichs der Slider

Max_Slider_x = 1000;
Max_Slider_y = 1000;
Max_Slider_z = 200;
global Daten;
Daten = [];

% Ausgabe-Figure definieren = 2
Daten.figure_Ausgabe = 2;



%% Definition des COM-Ports und der Gre und Position der figure

Daten.s = serial('COM5','baudrate',115200);
%Daten.s = 1; % Kommandofenster
Daten.handles.f = figure('Visible','off','Position',[360,500,500,400],'NumberTitle','off');

%% Panel fr Slider, Anzeige und Beschriftungen
%Panel_1 stellt die Bedienelemente fr die Sollwertvorgabe bereit
%Panel_2 stellt die Bediebelemente zum Starten und Stoppen der Seriellen
%Kommunikation bereit
%Panel_3 stellt den Pushbutton zum senden der Koordinaten an die Serielle
%Schnittstelle bereit.

Panel_1 = uipanel('Title','Sollwertvorgabe','Position',[0 .33 1 .33]);
Panel_2 = uipanel('Title','Kommunikation Starten/Stoppen','Position',[0 .8 1 .2]);
Panel_3 = uipanel('Title','Koordinaten 	','Position',[0 0 1 0.33]);
Panel_4 = uipanel('Title','ffnen,Start,Not-Aus-------------Neues Txt-Dokument: erneut ffnen drcken','Position',[0 .66 1 .133333]);

%% Aufbau der Slider
Daten.handles.Achse_x = uicontrol('Parent',Panel_1,'Style','slider','String','X-Achse',...
'Position',[100,80,300,20],...
'Min',0,'Max',Max_Slider_x,...
'SliderStep',[0.001 0.1],...
'Callback',{@achse_x_callback});

Daten.handles.Achse_y = uicontrol('Parent',Panel_1,'Style','slider','String','Y-Achse',...
'Position',[100,50,300,20],...
'Min',0,'Max',Max_Slider_y,...
'SliderStep',[0.001 0.1],...
'Callback',{@achse_y_callback});

Daten.handles.Achse_z = uicontrol('Parent',Panel_1,'Style','slider','String','Z-Achse',...
'Position',[100,20,300,20],...
'Min',0,'Max',Max_Slider_z,...
'SliderStep',[0.001 0.1],...
'Callback',{@achse_z_callback});


%% Aufbau der Beschriftungen der Slider
text_1 = uicontrol('Parent',Panel_1,'Style','Text','String','X-Achse',...
    'Position',[25,80,60,20]);

text_2 = uicontrol('Parent',Panel_1,'Style','Text','String','Y-Achse',...
    'Position',[25,50,60,20]);

text_3 = uicontrol('Parent',Panel_1,'Style','Text','String','Z-Achse',...
    'Position',[25,20,60,20]);

%Aufbau der Koordinatenanzeige
Koor_x = uicontrol('Parent',Panel_1,'Style','Text','String','',...
    'Position',[420,80,50,20],...
    'BackgroundColor','w');

Koor_y = uicontrol('Parent',Panel_1,'Style','Text','String','',...
    'Position',[420,50,50,20],...
    'BackgroundColor','w');

Koor_z = uicontrol('Parent',Panel_1,'Style','Text','String','',...
    'Position',[420,20,50,20],...
    'BackgroundColor','w');

%% Aufbau der Bedienelemente Starten und Stoppen der Seriellen
%Kommunikation
Starten = uicontrol('Parent',Panel_2,'Style','Pushbutton','String','Start',...
    'Position',[25, 30, 70, 25],...
    'BackgroundColor','green','FontWeight','bold','FontSize',10,...
    'Callback', @starten_callback);

Stoppen = uicontrol('Parent',Panel_2,'Style','Pushbutton','String','Stop',...
    'Position',[150,30,70,25],...
    'BackgroundColor','red','FontWeight','bold','FontSize',10,...
    'Callback', @stoppen_callback);

%% Aufbau des Pushbuttons zum Senden der Koordinaten an die Serielle
%Schnittstelle.
Senden = uicontrol('Parent',Panel_3,'Style','Pushbutton','String','senden',...
    'Position',[25,30,100,50],...
    'BackgroundColor',[0.5 0.7 1],'FontWeight','bold','FontSize',10,...
    'Callback', @senden_callback);




%% Aufbau Pushbutton Referenz senden und Referenz eingeben
 
Referenz_Senden = uicontrol('Parent',Panel_3,'Style','Pushbutton','String','Referenz senden',...
    'Position',[300,50,50,50],...
    'BackgroundColor',[0.5 0.7 1],'FontWeight','bold','FontSize',10,...
    'Callback', @Funk_Referenz);

%% Aufbau der Beschriftungen der Referenz

Daten.handles.Ref_x = uicontrol('Parent',Panel_3,'Style','edit','String','',...
    'Position',[400,80,50,20],...
    'BackgroundColor','w');

Daten.handles.Ref_y = uicontrol('Parent',Panel_3,'Style','edit','String','',...
    'Position',[400,50,50,20],...
    'BackgroundColor','w');

Daten.handles.Ref_z = uicontrol('Parent',Panel_3,'Style','edit','String','',...
    'Position',[400,20,50,20],...
    'BackgroundColor','w');
%% Aufbau des ffnen-/Start-/ Not-Aus-Button
Oeffnen = uicontrol('Parent',Panel_4,'Style','Pushbutton','String','ffnen',...
    'Position',[25, 5, 70, 25],...
    'BackgroundColor','white','FontWeight','bold','FontSize',10,...
    'Callback', 'Funk_Oeffnen;');

Start_Programm = uicontrol('Parent',Panel_4,'Style','Pushbutton','String','Start Frse',...
    'Position',[150, 5, 85, 25],...
    'BackgroundColor','green','FontWeight','bold','FontSize',10,...
    'Callback', 'Funk_Start_Programm(Daten);');

Simulation = uicontrol('Parent',Panel_4,'Style','Pushbutton','String','Simulation',...
    'Position',[250, 5, 85, 25],...
    'BackgroundColor','blue','FontWeight','bold','FontSize',10,...
    'Callback', 'Funk_Simulation;');

Not_Aus = uicontrol('Parent',Panel_4,'Style','Pushbutton','String','Not-Aus',...
    'Position',[400, 5, 70, 25],...
    'BackgroundColor','red','FontWeight','bold','FontSize',10,...
    'Callback', 'Funk_Not_Aus;');


%Initialisierung der GUI
set([Daten.handles.f ,Panel_1,Daten.handles.Achse_x,Daten.handles.Achse_y,Daten.handles.Achse_z,...
    text_1,text_2,text_3,...
    Koor_x,Koor_y,Koor_z,...
    Starten,Stoppen,...
    Senden],...
    'Units','normalized');

set(Daten.handles.f ,'Name','Sollwertvorgabe mit Slider')


%%
movegui(Daten.handles.f,'center')

set(Daten.handles.f ,'Visible','on');
set(Daten.handles.Achse_x,'Visible','off');
set(Daten.handles.Achse_y,'Visible','off');
set(Daten.handles.Achse_z,'Visible','off');
set(Senden,'Visible','off');